<html>
<head>
<title>OgreSphere.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSphere.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSphere_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Sphere_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Sphere_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00051"></a><a class="code" href="classOgre_1_1Sphere.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">protected</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1Sphere.html#a912c305cf5821240fe88a3a7ef59e67b">00054</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Sphere.html#a912c305cf5821240fe88a3a7ef59e67b">mRadius</a>;
<a name="l00055"></a><a class="code" href="classOgre_1_1Sphere.html#a4a6065226f4fbd7bc5f3cbe0c385d9c7">00055</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Sphere.html#a4a6065226f4fbd7bc5f3cbe0c385d9c7">mCenter</a>;
<a name="l00056"></a>00056     <span class="keyword">public</span>:
<a name="l00058"></a><a class="code" href="classOgre_1_1Sphere.html#a93cb05f8025668db930ef81a34dca47b">00058</a>         <a class="code" href="classOgre_1_1Sphere.html#a93cb05f8025668db930ef81a34dca47b" title="Standard constructor - creates a unit sphere around the origin.">Sphere</a>() : mRadius(1.0), mCenter(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO) {}
<a name="l00063"></a><a class="code" href="classOgre_1_1Sphere.html#abd0dc8dd45b400a07d71115652d2dc20">00063</a>         <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; center, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> radius)
<a name="l00064"></a>00064             : mRadius(radius), mCenter(center) {}
<a name="l00065"></a>00065 
<a name="l00067"></a><a class="code" href="classOgre_1_1Sphere.html#a8c0a5dee80bf790cdc5bd2a68f73a4c7">00067</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Sphere.html#a8c0a5dee80bf790cdc5bd2a68f73a4c7" title="Returns the radius of the sphere.">getRadius</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mRadius; }
<a name="l00068"></a>00068 
<a name="l00070"></a><a class="code" href="classOgre_1_1Sphere.html#aafe80cad31edd668b09981a6f836c8b1">00070</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Sphere.html#aafe80cad31edd668b09981a6f836c8b1" title="Sets the radius of the sphere.">setRadius</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> radius) { mRadius = radius; }
<a name="l00071"></a>00071 
<a name="l00073"></a><a class="code" href="classOgre_1_1Sphere.html#ab33e56a0df43b2dfe3b72b59757e6f69">00073</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="classOgre_1_1Sphere.html#ab33e56a0df43b2dfe3b72b59757e6f69" title="Returns the center point of the sphere.">getCenter</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCenter; }
<a name="l00074"></a>00074 
<a name="l00076"></a><a class="code" href="classOgre_1_1Sphere.html#af2cd29ca81e68cdeb65b91a2667d6fbc">00076</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Sphere.html#af2cd29ca81e68cdeb65b91a2667d6fbc" title="Sets the center point of the sphere.">setCenter</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; center) { mCenter = center; }
<a name="l00077"></a>00077 
<a name="l00079"></a><a class="code" href="classOgre_1_1Sphere.html#a26fc8402579d1256e222f34b6ac0ecf3">00079</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; s)<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword">        </span>{
<a name="l00081"></a>00081             <span class="keywordflow">return</span> (s.<a class="code" href="classOgre_1_1Sphere.html#a4a6065226f4fbd7bc5f3cbe0c385d9c7">mCenter</a> - mCenter).<a class="code" href="classOgre_1_1Vector3.html#ad465ee0d92aaa5e760b835b8f0db711d" title="Returns the square of the length(magnitude) of the vector.">squaredLength</a>() &lt;=
<a name="l00082"></a>00082                 <a class="code" href="classOgre_1_1Math.html#a626ae51af294ae54cee7e1e530937d7e" title="Squared function.">Math::Sqr</a>(s.<a class="code" href="classOgre_1_1Sphere.html#a912c305cf5821240fe88a3a7ef59e67b">mRadius</a> + mRadius);
<a name="l00083"></a>00083         }
<a name="l00085"></a><a class="code" href="classOgre_1_1Sphere.html#ace0763611fbf75e156d6e34d399d5468">00085</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box)<span class="keyword"> const</span>
<a name="l00086"></a>00086 <span class="keyword">        </span>{
<a name="l00087"></a>00087             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, box);
<a name="l00088"></a>00088         }
<a name="l00090"></a><a class="code" href="classOgre_1_1Sphere.html#aadca485853a6ae4535a3a9347ab6119b">00090</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane)<span class="keyword"> const</span>
<a name="l00091"></a>00091 <span class="keyword">        </span>{
<a name="l00092"></a>00092             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, plane);
<a name="l00093"></a>00093         }
<a name="l00095"></a><a class="code" href="classOgre_1_1Sphere.html#aa127d312d66a63b160825c4650c92e14">00095</a>         <span class="keywordtype">bool</span> intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; v)<span class="keyword"> const</span>
<a name="l00096"></a>00096 <span class="keyword">        </span>{
<a name="l00097"></a>00097             <span class="keywordflow">return</span> ((v - mCenter).squaredLength() &lt;= <a class="code" href="classOgre_1_1Math.html#a626ae51af294ae54cee7e1e530937d7e" title="Squared function.">Math::Sqr</a>(mRadius));
<a name="l00098"></a>00098         }
<a name="l00100"></a><a class="code" href="classOgre_1_1Sphere.html#a9e9104e8e57c2fa2d30920989c725d1a">00100</a>         <span class="keywordtype">void</span> merge(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; oth)
<a name="l00101"></a>00101         {
<a name="l00102"></a>00102             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> diff =  oth.<a class="code" href="classOgre_1_1Sphere.html#ab33e56a0df43b2dfe3b72b59757e6f69" title="Returns the center point of the sphere.">getCenter</a>() - mCenter;
<a name="l00103"></a>00103             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> lengthSq = diff.<a class="code" href="classOgre_1_1Vector3.html#ad465ee0d92aaa5e760b835b8f0db711d" title="Returns the square of the length(magnitude) of the vector.">squaredLength</a>();
<a name="l00104"></a>00104             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> radiusDiff = oth.<a class="code" href="classOgre_1_1Sphere.html#a8c0a5dee80bf790cdc5bd2a68f73a4c7" title="Returns the radius of the sphere.">getRadius</a>() - mRadius;
<a name="l00105"></a>00105             
<a name="l00106"></a>00106             <span class="comment">// Early-out</span>
<a name="l00107"></a>00107             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1Math.html#a626ae51af294ae54cee7e1e530937d7e" title="Squared function.">Math::Sqr</a>(radiusDiff) &gt;= lengthSq) 
<a name="l00108"></a>00108             {
<a name="l00109"></a>00109                 <span class="comment">// One fully contains the other</span>
<a name="l00110"></a>00110                 <span class="keywordflow">if</span> (radiusDiff &lt;= 0.0f) 
<a name="l00111"></a>00111                     <span class="keywordflow">return</span>; <span class="comment">// no change</span>
<a name="l00112"></a>00112                 <span class="keywordflow">else</span> 
<a name="l00113"></a>00113                 {
<a name="l00114"></a>00114                     mCenter = oth.<a class="code" href="classOgre_1_1Sphere.html#ab33e56a0df43b2dfe3b72b59757e6f69" title="Returns the center point of the sphere.">getCenter</a>();
<a name="l00115"></a>00115                     mRadius = oth.<a class="code" href="classOgre_1_1Sphere.html#a8c0a5dee80bf790cdc5bd2a68f73a4c7" title="Returns the radius of the sphere.">getRadius</a>();
<a name="l00116"></a>00116                     <span class="keywordflow">return</span>;
<a name="l00117"></a>00117                 }
<a name="l00118"></a>00118             }
<a name="l00119"></a>00119             
<a name="l00120"></a>00120             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length = <a class="code" href="classOgre_1_1Math.html#ab1ee8b71699ce68bd8cf91113ead793e" title="Square root function.">Math::Sqrt</a>(lengthSq);
<a name="l00121"></a>00121             
<a name="l00122"></a>00122             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> newCenter;
<a name="l00123"></a>00123             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> newRadius;
<a name="l00124"></a>00124             <span class="keywordflow">if</span> ((length + oth.<a class="code" href="classOgre_1_1Sphere.html#a8c0a5dee80bf790cdc5bd2a68f73a4c7" title="Returns the radius of the sphere.">getRadius</a>()) &gt; mRadius) 
<a name="l00125"></a>00125             {
<a name="l00126"></a>00126                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t = (length + radiusDiff) / (2.0f * length);
<a name="l00127"></a>00127                 newCenter = mCenter + diff * t;
<a name="l00128"></a>00128             } 
<a name="l00129"></a>00129             <span class="comment">// otherwise, we keep our existing center</span>
<a name="l00130"></a>00130             
<a name="l00131"></a>00131             newRadius = 0.5f * (length + mRadius + oth.<a class="code" href="classOgre_1_1Sphere.html#a8c0a5dee80bf790cdc5bd2a68f73a4c7" title="Returns the radius of the sphere.">getRadius</a>());
<a name="l00132"></a>00132             
<a name="l00133"></a>00133             mCenter = newCenter;
<a name="l00134"></a>00134             mRadius = newRadius;
<a name="l00135"></a>00135         }
<a name="l00136"></a>00136         
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     };
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="preprocessor">#endif</span>
<a name="l00145"></a>00145 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
